//+------------------------------------------------------------------+
//|                                                  Check_Money.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#property script_show_inputs
input double          lots=1.0;            //  
input ENUM_ORDER_TYPE type=ORDER_TYPE_BUY;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---     
   double margin;
//---     
   MqlTick last_tick;
//---      
   if(SymbolInfoTick(Symbol(),last_tick))
     {
      //---    
      ResetLastError();
      //---   
      bool check=OrderCalcMargin(type,Symbol(),lots,last_tick.ask,margin);
      if(check)
        {
         PrintFormat("  %s  %s %.2f lot at %G  %.2f %s",OrderTypeToString(type),
                     Symbol(),lots,last_tick.ask,margin,AccountInfoString(ACCOUNT_CURRENCY));
        }
     }
   else
     {
      Print("   SymbolInfoTick(),  ",GetLastError());
     }

//---     
   PrintFormat("  : %G %s",AccountInfoDouble(ACCOUNT_FREEMARGIN),AccountInfoString(ACCOUNT_CURRENCY));

//---         
   PrintFormat("       %G",SymbolInfoDouble(Symbol(),SYMBOL_MARGIN_LONG));
   PrintFormat("        %G",SymbolInfoDouble(Symbol(),SYMBOL_MARGIN_SHORT));
   PrintFormat("    Limit   %G",SymbolInfoDouble(Symbol(),SYMBOL_MARGIN_LIMIT));
   PrintFormat("    Stop   %G",SymbolInfoDouble(Symbol(),SYMBOL_MARGIN_STOP));
   PrintFormat("    Stop Limit   %G",SymbolInfoDouble(Symbol(),SYMBOL_MARGIN_STOPLIMIT));

  }
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
string OrderTypeToString(ENUM_ORDER_TYPE t)
  {
   switch(t)
     {
      case ORDER_TYPE_BUY:            return "buy";
      case ORDER_TYPE_SELL:           return "sell";
      case ORDER_TYPE_BUY_LIMIT:      return "buy limit";
      case ORDER_TYPE_SELL_LIMIT:     return "sell limit";
      case ORDER_TYPE_BUY_STOP:       return "buy stop";
      case ORDER_TYPE_SELL_STOP:      return "sell stop";
      case ORDER_TYPE_BUY_STOP_LIMIT: return "buy stop limit";
      case ORDER_TYPE_SELL_STOP_LIMIT:return "sell stop limit";
      default:                        return "unknown type of order";
     }
   return "";
  }
//+------------------------------------------------------------------+
