//+------------------------------------------------------------------+
//|                                Check_Order_And_Volume_Limits.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- 
   string com="";

//---        
   if(IsNewOrderAllowed())
      StringAdd(com,"   ");
   else
      StringAdd(com,"   ");
//---   
   StringAdd(com,"\r\n");

//---        
   double new_order_volume=NewOrderAllowedVolume(Symbol());
   StringAdd(com,"      "+Symbol()
             +", : "+DoubleToString(new_order_volume,2));

//---  
   Comment(com);
  }
//+------------------------------------------------------------------+
//|  -                   |
//+------------------------------------------------------------------+
bool IsNewOrderAllowed()
  {
//---       
   int max_allowed_orders=(int)AccountInfoInteger(ACCOUNT_LIMIT_ORDERS);

//---    -  true,   
   if(max_allowed_orders==0) return(true);

//---     ,   ,     
   int orders=OrdersTotal();

//---   
   return(orders<max_allowed_orders);
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
double PositionVolume(string symbol)
  {
//---     
   bool selected=PositionSelect(symbol);
//---  
   if(selected)
      //---   
      return(PositionGetDouble(POSITION_VOLUME));
   else
     {
      //---     
      return(0);
     }
  }
//+------------------------------------------------------------------+
//|            |
//+------------------------------------------------------------------+
double NewOrderAllowedVolume(string symbol)
  {
   double allowed_volume=0;
//---       
   double symbol_max_volume=SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MAX);
//---      
   double max_volume=SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_LIMIT);

//---      
   double opened_volume=PositionVolume(symbol);
   if(opened_volume>=0)
     {
      //---     
      if(max_volume-opened_volume<=0)
         return(0);

      //---      max_volume
      double orders_volume_on_symbol=PendingsVolume(symbol);
      allowed_volume=max_volume-opened_volume-orders_volume_on_symbol;
      if(allowed_volume>symbol_max_volume) allowed_volume=symbol_max_volume;
     }
   return(allowed_volume);
  }
//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
double   PendingsVolume(string symbol)
  {
   double volume_on_symbol=0;
   ulong ticket;
//---         
   int all_orders=OrdersTotal();

//---      
   for(int i=0;i<all_orders;i++)
     {
      //---        
      if(ticket=OrderGetTicket(i))
        {
         //---      ,    
         if(symbol==OrderGetString(ORDER_SYMBOL))
            volume_on_symbol+=OrderGetDouble(ORDER_VOLUME_INITIAL);
        }
     }
//---         
   return(volume_on_symbol);
  }
//+------------------------------------------------------------------+
