//+------------------------------------------------------------------+
//|                                            SymbolInfoSession.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void PrintInfoForQuoteSessions(string symbol,ENUM_DAY_OF_WEEK day)
  {
//---    
   datetime start,finish;
   uint session_index=0;
   bool session_exist=true;

//---       
   while(session_exist)
     {
      //---       session_index
      session_exist=SymbolInfoSessionQuote(symbol,day,session_index,start,finish);

      //---    
      if(session_exist)
        {
         //---   ,       
         Print(DayToString(day),": session index=",session_index,"  start=",
               TimeToString(start,TIME_MINUTES),"    finish=",TimeToString(finish-1,TIME_MINUTES|TIME_SECONDS));
        }
      //---   
      session_index++;
     }
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void PrintInfoForTradeSessions(string symbol,ENUM_DAY_OF_WEEK day)
  {
//---    
   datetime start,finish;
   uint session_index=0;
   bool session_exist=true;

//---       
   while(session_exist)
     {
      //---       session_index
      session_exist=SymbolInfoSessionTrade(symbol,day,session_index,start,finish);

      //---    
      if(session_exist)
        {
         //---   ,       
         Print(DayToString(day),": session index=",session_index,"  start=",
               TimeToString(start,TIME_MINUTES),"    finish=",TimeToString(finish-1,TIME_MINUTES|TIME_SECONDS));
        }
      //---   
      session_index++;
     }
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
string DayToString(ENUM_DAY_OF_WEEK day)
  {
   switch(day)
     {
      case SUNDAY:    return "Sunday";
      case MONDAY:    return "Monday";
      case TUESDAY:   return "Tuesday";
      case WEDNESDAY: return "Wednesday";
      case THURSDAY:  return "Thursday";
      case FRIDAY:    return "Friday";
      case SATURDAY:  return "Saturday";
      default:        return "Unknown day of week";
     }
   return "";
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//--- ,     
   ENUM_DAY_OF_WEEK days[]={SUNDAY,MONDAY,TUESDAY,WEDNESDAY,THURSDAY,FRIDAY,SATURDAY};
   int size=ArraySize(days);

//---
   Print(" ");
//---     
   for(int d=0;d<size;d++)
     {
      PrintInfoForQuoteSessions(Symbol(),days[d]);
     }

//---
   Print(" ");
//---     
   for(int d=0;d<size;d++)
     {
      PrintInfoForTradeSessions(Symbol(),days[d]);
     }
  }
//+------------------------------------------------------------------+
